100 :
101 : REM \{vi} Eagle1 \{vn}
102 REM Eagle 1 (Lander)
103 REM (c) 2022 by Zarsoft
104 REM demo for Pascalated BASIC contest
105 REM CLEAR 64599
106 REM CLEAR variables
107 REM VAR - Global variables
108 GO SUB 9905 : REM call init proc addrs
109 POKE 23606,0 : POKE 23607,60 : REM ZX Chars
110 REM CONSTant declarations
111 LET true = 1
112 LET false = 0
113 LET gravity = 9.8
114 LET k = 0.04
115 LET thrust = 1
116 LET MaxFuel = 200
117 REM VARiable declarations
118 LET MinSpeed = 999
119 LET MaxScore = -1
120 DIM u$(8,5) : REM Sprites, upper line
121 DIM v$(8,5) : REM Sprites, bottom line
122 REM w - cicle level 1
123 REM q - cicle level 2
124 REM g - cicle level 3
125 GO SUB LoadBackground
126 GO SUB InitSprites
127 GO SUB ClearStory
128 GO SUB MainRoutine
129 STOP : REM Eagle1 
200 :
201 : REM \{vi} MainRoutine \{vn}
202 LET MainRoutine = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
203 FOR w = 0 TO 0.5 STEP 0 : REM REPEAT
204   GO SUB Lander
205   LET w = false : REM UNTIL
206 NEXT w : REM UNTIL
207 GO SUB GameOver
208 RETURN : REM MainRoutine 
300 :
301 : REM \{vi} Lander \{vn}
302 LET Lander = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
303 GO SUB InitVariables
304 GO SUB DrawScreen
305 IF MaxScore < 0 THEN GO SUB GetReady
306 FOR q = 0 TO 0.5 STEP 0 : REM REPEAT
307   LET k$ = INKEY$
308   IF k$ = "0" THEN IF fuel > 0 THEN LET DY = DY + thrust : LET fuel = fuel - 10
309   LET DY = DY - k*gravity : REM gravity
310   LET y = y + DY
311   LET yy = INT(y+0.5)
312   IF yy < 0 THEN LET yy = 0 : LET Landed = true
313   IF yy > 175-8 THEN LET yy = 175-8
314   LET lin = 21-INT (yy/8)
315   LET ix = 1+yy-8*INT(yy/8)
316   POKE 23606,88 : POKE 23607,251 : REM Sprite
317   PRINT AT lin-1,15;u$(ix)
318   PRINT AT lin,15;v$(ix)
319   IF lin > 1 THEN PRINT AT lin-2,15;"     "; : IF ABS DY > 8 THEN PRINT AT lin-3,15;"     ";
320   IF lin < 21 THEN PRINT AT lin+1,15;"     ";
321   POKE 23606,0 : POKE 23607,60 : REM ZX Chars
322   PRINT INK 6;AT 0,0;"Fuel:    ";fuel;" "
323   PRINT INK 6;AT 1,0;"Height:  ";ABS INT y;" "
324   PRINT INK 5;AT 2,0;"Speed:   ";INT(10*ABS DY)/10;"  "
325   LET q = Landed : REM UNTIL
326 NEXT q : REM UNTIL
327 GO SUB Report
328 RETURN : REM Lander 
400 :
401 : REM \{vi} InitVariables \{vn}
402 LET InitVariables = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
403 LET x = 150
404 LET y = 175-8
405 LET yy = y
406 LET fuel = MaxFuel
407 LET DY = 0
408 LET Landed = false
409 RETURN : REM InitVariables 
500 :
501 : REM \{vi} DrawScreen \{vn}
502 LET DrawScreen = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
503 PRINT PAPER 2;INK 0;BRIGHT 1;AT 0, 22;" EAGLE 1 "
504 PRINT INK 6;AT 0,0;"Fuel:    ";fuel;" "
505 PRINT INK 6;AT 1,0;"Height:  ";ABS INT y;" "
506 PRINT INK 5;AT 2,0;"Speed:   ";INT(10*ABS DY)/10;"  "
507 RETURN : REM DrawScreen 
600 :
601 : REM \{vi} Report \{vn}
602 LET Report = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
603 IF INT(100*ABS DY)/100 < MinSpeed THEN LET MinSpeed = INT(100*ABS DY)/100
604 LET Score = ABS INT((2000+fuel)/(2^ABS DY))
605 IF Score > MaxScore THEN LET MaxScore = Score
606 PRINT INK 6;AT 1,0;"Height:  ";0;"  "
607 PRINT INK 4;AT 3,0;"MinSpeed:";MinSpeed;"    "
608 PRINT INK 4;AT 4,0;"MaxScore:";MaxScore;
609 LET g = Score = 0 : REM IF-BEGIN
610 FOR g = g TO 0.5 STEP -2 : REM IF-BEGIN
611   LET m$ = "You fell like a rock!"
612   LET n$ = "Press 0 to thrust."
613   PRINT AT 21,15;OVER 1;PAPER 8;INK 3;"     ";
614 NEXT g : REM ENDIF
615 LET g = (g<0)*-1 + (g=0)*( Score < 500 ) : REM ELSEIF
616 FOR g = g TO 0.5 STEP -2 : REM ELSEIF
617   LET m$ = "You are a beginner."
618   LET n$ = "Try to be an amateur."
619   PRINT AT 21,15;OVER 1;PAPER 8;INK 6;"     ";
620 NEXT g : REM ENDIF
621 LET g = (g<0)*-1 + (g=0)*( Score < 1000 ) : REM ELSEIF
622 FOR g = g TO 0.5 STEP -2 : REM ELSEIF
623   LET m$ = "You are an amateur."
624   LET n$ = "Try to be a professional."
625   PRINT AT 21,15;OVER 1;PAPER 8;INK 5;"     ";
626 NEXT g : REM ENDIF
627 LET g = (g=0) : REM ELSE
628 FOR g = g TO 0.5 STEP -2 : REM ELSE
629   LET m$ = "You are a professional!"
630   LET n$ = "You are wasting your time here!"
631   PRINT AT 21,15;OVER 1;PAPER 8;INK 4;"     ";
632 NEXT g : REM ENDIF
633 PRINT AT 6,0;INK 3;"Score: ";Score
634 PRINT AT 8,0;INK 4;m$
635 PRINT AT 9,0;INK 4;n$
636 REM wait a few seconds
637 LET t = PEEK 23672 + 3*50
638 IF t > 255 THEN LET t = t - 255
639 FOR g = 0 TO 0.5 STEP 0 : REM REPEAT
640   LET g = ABS (t - PEEK 23672) < 5 : REM UNTIL
641 NEXT g : REM UNTIL
642 GO SUB GetReady
643 PRINT AT 6,0;"            "
644 PRINT AT 8,0;INK 4;"                               "
645 PRINT AT 9,0;INK 4;"                               "
646 PRINT AT 20,15;"     ";
647 PRINT AT 21,15;"     ";
648 RETURN : REM Report 
700 :
701 : REM \{vi} GetReady \{vn}
702 LET GetReady = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
703 PRINT AT 11,0;INK 5;"Press 1 to start"
704 FOR g = 0 TO 0.5 STEP 0 : REM REPEAT
705   LET g = INKEY$ = "1" : REM UNTIL
706 NEXT g : REM UNTIL
707 PRINT AT 11,0;INK 5;"                "
708 RETURN : REM GetReady 
800 :
801 : REM \{vi} InitSprites \{vn}
802 LET InitSprites = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
803 LET RAMTOP = 23730 : REM (87,255)=65367=65535-21*8
804 LET SIZE = 936 : REM 96*8 + 21*8
805 LET NEWTOP = 64599 : REM 65535-936
806 REM CLEAR 64599
807 LET CHARS = 23606 : REM (0,61-1) = 15616-256
808 LET CharsUDG = USR "A" : REM 65368 = 65536-21*8
809 LET CharsSprites = 64600 : REM 65536-21*8-96*8
810 REM CharsSprites POKE = (344,251)
811 REM Define Lines
812 LET message = 0
813 GO SUB TellStory
814 LET n=32
815 FOR s=0 TO 7
816   FOR c=0 TO 4
817     LET u$(s+1,c+1) = CHR$(n)
818     LET n = n+1
819   NEXT c
820   FOR c=0 TO 4
821     LET v$(s+1,c+1) = CHR$(n)
822     LET n = n+1
823   NEXT c
824 NEXT s
825 REM Define Sprites
826 FOR s=7 TO 0 STEP -1
827   GO SUB TellStory
828   RESTORE DataSprite+s
829   LET dest = CharsSprites + 2*5*8*s
830   REM upper line
831   FOR b=0 TO 7
832     FOR r=0 TO 4
833       READ n
834       POKE dest+b+r*8,n
835     NEXT r
836   NEXT b
837   LET dest = dest + 5*8
838   REM bottom line
839   FOR b=0 TO 7
840     FOR r=0 TO 4
841       READ n
842       POKE dest+b+r*8,n
843     NEXT r
844   NEXT b
845   REM print eagle
846   POKE 23606,88 : POKE 23607,251 : REM Sprite
847   PRINT AT 0,15;v$(s+1);
848   POKE 23606,0 : POKE 23607,60 : REM ZX Chars
849 NEXT s
850 RETURN : REM InitSprites 
900 :
901 : REM \{vi} DataSprite \{vn}
902 LET DataSprite = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
903 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
904 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
905 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
906 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
907 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
908 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
909 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
910 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
911 DATA BIN 00000000, BIN 01111111, BIN 11111111, BIN 11111111, BIN 11100001
912 DATA BIN 00011110, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11110111
913 DATA BIN 01111111, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11111111
914 DATA BIN 01111111, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11110111
915 DATA BIN 00011110, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11100001
916 DATA BIN 00000000, BIN 00011110, BIN 00000000, BIN 00001111, BIN 00000000
917 DATA BIN 00000000, BIN 00001100, BIN 00000000, BIN 00000110, BIN 00000000
918 DATA BIN 00000000, BIN 00011110, BIN 00000000, BIN 00001111, BIN 00000000
919 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
920 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
921 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
922 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
923 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
924 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
925 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
926 DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
927 RETURN : REM DataSprite 
1000 :
1001 : REM \{vi} TellStory \{vn}
1002 LET TellStory = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
1003 GO SUB ClearStory
1004 RESTORE DataStory + message
1005 READ m$
1006 PRINT AT  8,0;INK 4;m$
1007 READ m$
1008 PRINT AT  9,0;INK 4;m$
1009 LET message = message + 1
1010 RETURN : REM TellStory 
1100 :
1101 : REM \{vi} DataStory \{vn}
1102 LET DataStory = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
1103 DATA "Hello!", "Do you read me?"
1104 DATA "This is Dr Helena Russel,", "calling Moonbase Alpha."
1105 DATA "We are in danger:", "Pilot Alan Carter is sick."
1106 DATA "You are our only hope.", "God help us!"
1107 DATA "You need to land the Eagle 1", "by remote control."
1108 DATA "We are arriving.", "Please stand by."
1109 DATA "This game has no sound. In Space,", "no one can hear you scream..."
1110 DATA "This game is a demo for the", "2022 Pascalated BASIC contest."
1111 DATA "Greatings from the", "Planeta Sinclair blog."
1112 DATA ""
1113 RETURN : REM DataStory 
1200 :
1201 : REM \{vi} ClearStory \{vn}
1202 LET ClearStory = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
1203 PRINT AT  8,0;
1204 PRINT " ";TAB 0;" ";TAB 0;
1205 RETURN : REM ClearStory 
1300 :
1301 : REM \{vi} LoadBackground \{vn}
1302 LET LoadBackground = 1+PEEK 23621+256*PEEK 23622 : RETURN : REM set proc addr
1303 BORDER 0 : PAPER 0 : INK 7 : CLS
1304 LOAD "" SCREEN$
1305 RETURN : REM LoadBackground 
9900 :
9902 : REM \{vi} init proc addrs \{vn}
9904 LET w = 9999 : RETURN
9908 PRINT FLASH 1;" "; AT 0,0;
9910 FOR w = 200 TO 9900 STEP 100
9912 GO SUB w
9914 NEXT w
9916 RETURN : REM init proc addrs
9918 REM converted from
9920 REM Pascalated BASIC
9922 REM to Structured BASIC
9924 REM at www.ArcaLusitana.org/MuseuZX
9926 REM (c) 1987, 2021 by ZarSoft
