PROGRAM Eagle1
REM Eagle 1 (Lander)
REM (c) 2022 by Zarsoft
REM demo for Pascalated BASIC contest
REM CLEAR 64599
POKE 23606,0 : POKE 23607,60 : REM ZX Chars
REM CONSTant declarations
LET true = 1
LET false = 0
LET gravity = 9.8
LET k = 0.04
LET thrust = 1
LET MaxFuel = 200
REM VARiable declarations
LET MinSpeed = 999
LET MaxScore = -1
DIM u$(8,5) : REM Sprites, upper line
DIM v$(8,5) : REM Sprites, bottom line
REM w - cicle level 1
REM q - cicle level 2
REM g - cicle level 3
PROC LoadBackground
PROC InitSprites
PROC ClearStory
PROC MainRoutine
END

DEFPROC MainRoutine
REPEAT w
  PROC Lander
UNTIL false
PROC GameOver
ENDPROC

DEFPROC Lander
PROC InitVariables
PROC DrawScreen
IF MaxScore < 0 THEN PROC GetReady
REPEAT q
  LET k$ = INKEY$
  IF k$ = "0" THEN IF fuel > 0 THEN LET DY = DY + thrust : LET fuel = fuel - 10
  LET DY = DY - k*gravity : REM gravity
  LET y = y + DY
  LET yy = INT(y+0.5)
  IF yy < 0 THEN LET yy = 0 : LET Landed = true
  IF yy > 175-8 THEN LET yy = 175-8
  LET lin = 21-INT (yy/8)
  LET ix = 1+yy-8*INT(yy/8)
  POKE 23606,88 : POKE 23607,251 : REM Sprite
  PRINT AT lin-1,15;u$(ix)
  PRINT AT lin,15;v$(ix)
  IF lin > 1 THEN PRINT AT lin-2,15;"     "; : IF ABS DY > 8 THEN PRINT AT lin-3,15;"     ";
  IF lin < 21 THEN PRINT AT lin+1,15;"     ";
  POKE 23606,0 : POKE 23607,60 : REM ZX Chars
  PRINT INK 6;AT 0,0;"Fuel:    ";fuel;" "
  PRINT INK 6;AT 1,0;"Height:  ";ABS INT y;" "
  PRINT INK 5;AT 2,0;"Speed:   ";INT(10*ABS DY)/10;"  "
UNTIL Landed
PROC Report
ENDPROC

DEFPROC InitVariables
LET x = 150
LET y = 175-8
LET yy = y
LET fuel = MaxFuel
LET DY = 0
LET Landed = false
ENDPROC

DEFPROC DrawScreen
PRINT PAPER 2;INK 0;BRIGHT 1;AT 0, 22;" EAGLE 1 "
PRINT INK 6;AT 0,0;"Fuel:    ";fuel;" "
PRINT INK 6;AT 1,0;"Height:  ";ABS INT y;" "
PRINT INK 5;AT 2,0;"Speed:   ";INT(10*ABS DY)/10;"  "
ENDPROC

DEFPROC Report
IF INT(100*ABS DY)/100 < MinSpeed THEN LET MinSpeed = INT(100*ABS DY)/100
LET Score = ABS INT((2000+fuel)/(2^ABS DY))
IF Score > MaxScore THEN LET MaxScore = Score
PRINT INK 6;AT 1,0;"Height:  ";0;"  "
PRINT INK 4;AT 3,0;"MinSpeed:";MinSpeed;"    "
PRINT INK 4;AT 4,0;"MaxScore:";MaxScore;
IF Score = 0 BEGIN g
  LET m$ = "You fell like a rock!"
  LET n$ = "Press 0 to thrust."
  PRINT AT 21,15;OVER 1;PAPER 8;INK 3;"     ";
ELSEIF Score < 500
  LET m$ = "You are a beginner."
  LET n$ = "Try to be an amateur."
  PRINT AT 21,15;OVER 1;PAPER 8;INK 6;"     ";
ELSEIF Score < 1000
  LET m$ = "You are an amateur."
  LET n$ = "Try to be a professional."
  PRINT AT 21,15;OVER 1;PAPER 8;INK 5;"     ";
ELSE
  LET m$ = "You are a professional!"
  LET n$ = "You are wasting your time here!"
  PRINT AT 21,15;OVER 1;PAPER 8;INK 4;"     ";
ENDIF
PRINT AT 6,0;INK 3;"Score: ";Score
PRINT AT 8,0;INK 4;m$
PRINT AT 9,0;INK 4;n$
REM wait a few seconds
LET t = PEEK 23672 + 3*50
IF t > 255 THEN LET t = t - 255
REPEAT g
UNTIL ABS (t - PEEK 23672) < 5
PROC GetReady
PRINT AT 6,0;"            "
PRINT AT 8,0;INK 4;"                               "
PRINT AT 9,0;INK 4;"                               "
PRINT AT 20,15;"     ";
PRINT AT 21,15;"     ";
ENDPROC

DEFPROC GetReady
PRINT AT 11,0;INK 5;"Press 1 to start"
REPEAT g
UNTIL INKEY$ = "1"
PRINT AT 11,0;INK 5;"                "
ENDPROC

DEFPROC InitSprites
LET RAMTOP = 23730 : REM (87,255)=65367=65535-21*8
LET SIZE = 936 : REM 96*8 + 21*8
LET NEWTOP = 64599 : REM 65535-936
REM CLEAR 64599
LET CHARS = 23606 : REM (0,61-1) = 15616-256
LET CharsUDG = USR "A" : REM 65368 = 65536-21*8
LET CharsSprites = 64600 : REM 65536-21*8-96*8
REM CharsSprites POKE = (344,251)
REM Define Lines
LET message = 0
PROC TellStory
LET n=32
FOR s=0 TO 7
  FOR c=0 TO 4
    LET u$(s+1,c+1) = CHR$(n)
    LET n = n+1
  NEXT c
  FOR c=0 TO 4
    LET v$(s+1,c+1) = CHR$(n)
    LET n = n+1
  NEXT c
NEXT s
REM Define Sprites
FOR s=7 TO 0 STEP -1
  PROC TellStory
  RESTORE DataSprite+s
  LET dest = CharsSprites + 2*5*8*s
  REM upper line
  FOR b=0 TO 7
    FOR r=0 TO 4
      READ n
      POKE dest+b+r*8,n
    NEXT r
  NEXT b
  LET dest = dest + 5*8
  REM bottom line
  FOR b=0 TO 7
    FOR r=0 TO 4
      READ n
      POKE dest+b+r*8,n
    NEXT r
  NEXT b
  REM print eagle
  POKE 23606,88 : POKE 23607,251 : REM Sprite
  PRINT AT 0,15;v$(s+1);
  POKE 23606,0 : POKE 23607,60 : REM ZX Chars
NEXT s
ENDPROC

DEFPROC DataSprite
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 01111111, BIN 11111111, BIN 11111111, BIN 11100001
DATA BIN 00011110, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11110111
DATA BIN 01111111, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11111111
DATA BIN 01111111, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11110111
DATA BIN 00011110, BIN 11111111, BIN 11111111, BIN 11111111, BIN 11100001
DATA BIN 00000000, BIN 00011110, BIN 00000000, BIN 00001111, BIN 00000000
DATA BIN 00000000, BIN 00001100, BIN 00000000, BIN 00000110, BIN 00000000
DATA BIN 00000000, BIN 00011110, BIN 00000000, BIN 00001111, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
DATA BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000, BIN 00000000
ENDPROC

DEFPROC TellStory
PROC ClearStory
RESTORE DataStory + message
READ m$
PRINT AT  8,0;INK 4;m$
READ m$
PRINT AT  9,0;INK 4;m$
LET message = message + 1
ENDPROC

DEFPROC DataStory
DATA "Hello!", "Do you read me?"
DATA "This is Dr Helena Russel,", "calling Moonbase Alpha."
DATA "We are in danger:", "Pilot Alan Carter is sick."
DATA "You are our only hope.", "God help us!"
DATA "You need to land the Eagle 1", "by remote control."
DATA "We are arriving.", "Please stand by."
DATA "This game has no sound. In Space,", "no one can hear you scream..."
DATA "This game is a demo for the", "2022 Pascalated BASIC contest."
DATA "Greatings from the", "Planeta Sinclair blog."
DATA ""
ENDPROC

DEFPROC ClearStory
PRINT AT  8,0;
PRINT " ";TAB 0;" ";TAB 0;
ENDPROC

DEFPROC LoadBackground
BORDER 0 : PAPER 0 : INK 7 : CLS
LOAD "" SCREEN$
ENDPROC

